<?php

declare(strict_types=1);

namespace App\Service;

use App\Repository\TblRespuestasXUsuarioCursoRepository;

final class TblRespuestasXUsuarioCursoService
{
    private TblRespuestasXUsuarioCursoRepository $TblRespuestasXUsuarioCursoRepository;

    public function __construct(TblRespuestasXUsuarioCursoRepository $TblRespuestasXUsuarioCursoRepository)
    {
        $this->TblRespuestasXUsuarioCursoRepository = $TblRespuestasXUsuarioCursoRepository;
    }

    public function checkAndGet(int $TblRespuestasXUsuarioCursoId): object
    {
        return $this->TblRespuestasXUsuarioCursoRepository->checkAndGet($TblRespuestasXUsuarioCursoId);
    }

    public function getAll(): array
    {
        return $this->TblRespuestasXUsuarioCursoRepository->getAll();
    }

    public function getOne(int $TblRespuestasXUsuarioCursoId): object
    {
        return $this->checkAndGet($TblRespuestasXUsuarioCursoId);
    }

    public function create(array $input): object
    {
        $TblRespuestasXUsuarioCurso = json_decode((string) json_encode($input), false);

        return $this->TblRespuestasXUsuarioCursoRepository->create($TblRespuestasXUsuarioCurso);
    }

    public function update(array $input, int $TblRespuestasXUsuarioCursoId): object
    {
        $TblRespuestasXUsuarioCurso = $this->checkAndGet($TblRespuestasXUsuarioCursoId);
        $data = json_decode((string) json_encode($input), false);

        return $this->TblRespuestasXUsuarioCursoRepository->update($TblRespuestasXUsuarioCurso, $data);
    }

    public function delete(int $TblRespuestasXUsuarioCursoId): void
    {
        $this->checkAndGet($TblRespuestasXUsuarioCursoId);
        $this->TblRespuestasXUsuarioCursoRepository->delete($TblRespuestasXUsuarioCursoId);
    }
}
